function cleverThumb($id, $width=50, $height=50, $only_src=false, $alt="", $attr=""){
  //ini_set('display_errors', 1);
  global $wpdb;
  /* CONFIGURE THESE VARIABLES */
  
  # Set the path where the class.ImageToolbox.php is
  $imageToolBox_path  = dirname(__FILE__)."/scripts/class.ImageToolbox.php";

  # Set the destination path where the thumbs will be saved 
  $synPublicPath      = "/wp-content/uploads/thumbs/";

  /* STOP. Modify at your own risk */  
  include_once ($imageToolBox_path);
  $src="";
  
  $images = get_children(array('post_parent' => $id,'post_status' => 'inherit','post_type' => 'attachment','post_mime_type' => 'image','order' => 'ASC','orderby' => 'menu_order'));
  if ( $images ) {
    //echo "<pre>";print_r($images);echo "</pre>";
    $images=array_reverse($images);
    $image=array_pop($images);
    $img = wp_get_attachment_image_src( $image->ID, 'full' );
    $image_src=$img[0];
  }

  if ($image_src=="") {
    $the_content =$wpdb->get_var("SELECT post_content FROM $wpdb->posts WHERE ID = $id");
    $pattern = '!<img.*?src="(.*?)"!';
    preg_match_all($pattern, $the_content, $matches);
    $image_src = $matches['1'][0];
  }
  if ($image_src=="") return;

  $image_src_arr = parse_url($image_src);
  
  if ($image_src_arr['host']!="" and false) {
    $loc=$synPublicPath.str_replace(array('/','+'),'-',$image_src_arr['path']);
  	if (!file_exists($_SERVER['DOCUMENT_ROOT'].$loc)) {
      if( ini_get('allow_url_fopen') ) {
				copy($image_src, getenv("DOCUMENT_ROOT").$loc);
			} else return;
  	} 
    $image_src = $loc;
    $image_src_arr = parse_url($image_src);
  }
 
  $img=$image_src_arr["path"];
  $imgArr = @getimagesize(getenv("DOCUMENT_ROOT").$img);

  $resultimg   = $synPublicPath.$imgArr[0]."x".$imgArr[1]."-".basename($img);
  $typeArr=split("/",$imgArr['mime']);
  $type=$typeArr[1];
  
  if (!file_exists($_SERVER['DOCUMENT_ROOT'].$img)) return;

  $tmb_exists  = file_exists($_SERVER['DOCUMENT_ROOT'].$resultimg);
  $img_created = date("Y-m-d H:i:s", @filectime($_SERVER['DOCUMENT_ROOT'].$img));
  $tmb_created = date("Y-m-d H:i:s", @filectime($_SERVER['DOCUMENT_ROOT'].$resultimg));
  $imgArr = @getimagesize(getenv("DOCUMENT_ROOT").$resultimg);
  
  if ($tmb_exists) $sameSize= ($imgArr["width"]==$width) and ($imgArr["height"]==$height);
  if (!$tmb_exists || ($tmb_exists && ($img_created > $tmb_created)) || !$sameSize ){
    $thumbnail = new Image_Toolbox(getenv("DOCUMENT_ROOT").$img);
    $thumbnail-> setResizeMethod('resample');
    $thumbnail-> newOutputSize($width, $height, 1, false, '#FFFFFF');
    $thumbnail-> save(getenv("DOCUMENT_ROOT")."/".$resultimg, $type);
  }
  if ($only_src===true) return $resultimg;
  else return "<img src=\"".$resultimg."\" alt=\"".str_replace("\"","",htmlentities($alt))."\" ".$attr."/>";
}
